<template>
  <div class="row">
    <div class="col-8">
      <div class="card card-default">
        <div class="card-header">Messages</div>
        <div class="card-body p-0">
          <ul class="list-unstyled" style="height:300px;overflow-y:scroll" v-chat-scroll>
            <li class="p-2" v-for="(message,index) in messages" :key="index">
              <strong>{{ message.user.name }}</strong>
              {{ message.message }}
            </li>
          </ul>
        </div>

        <input
          @keydown="sendTypingEvent"
          @keyup.enter="sendMessage"
          v-model="newMessage"
          type="text"
          name="message"
          id="message"
          placeholder="Enter your message..."
          class="form-control"
        />
      </div>
      <span class="text-muted" v-if="activeUser">{{activeUser.name}} is typing...</span>
    </div>
    <div class="col-4">
      <!-- component to list of users -->
      <div class="card card-default">
        <div class="card-header">Active Users</div>
        <div class="card-body"></div>
        <ul>
          <li class="py-2" v-for="(user, index) in users" :key="index">{{ user.name }}</li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: ["user"],

  data() {
    return {
      messages: [],
      newMessage: "",
      users: [],
      activeUser: false,
      typingTimer: false,
      timeout: null
    };
  },

  created() {
    //typing channel
    // window.Echo.join("typing")
    //   .here(res => {
    //     // console.log(res);
    //   })
    //   .listen(".user.typing", res => {
    //     console.log("fff");
    //   })
    //   .listenForWhisper("typing", user => {
    //     console.log("ggg");
    //   });

    //channel - public
    // window.Echo.channel("chat").listen(".examplee", e => {

    //presence channel
    window.Echo.join("chat")
      .here(user => {
        this.users = user;
      })
      .joining(user => {
        this.users.push(user);
      })
      .leaving(user => {
        this.users = this.users.filter(u => u.id != user.id);
      })
      .listen(".message.sent", e => {
        // console.log(e);
        this.activeUser = false;//remove user typing as soon as message is received
        this.messages.push(e.message);
      })
      .listen(".user.typing", e => {
        // console.log(e);

        this.activeUser = e.user;
        if (this.typingTimer) {
          clearTimeout(this.typingTimer);
        }
        this.typingTimer = setTimeout(() => {
          this.activeUser = false;
        }, 500);
      })
      .listenForWhisper(".user.typing", user => {
        console.log("ggg");
      });

    this.fetchMessages();
  },

  methods: {
    fetchMessages() {
      axios.get("messages").then(response => {
        // console.log(response);
        this.messages = response.data;
      });
    },

    sendMessage() {
      this.messages.push({
        user: this.user,
        message: this.newMessage
      });

      axios.post("messages", { message: this.newMessage });
      this.newMessage = "";
    },

    sendTypingEvent() {
      // window.Echo.join("chat").whisper("typing", this.user);

      if (this.timeout) {
        clearTimeout(this.timeout);
      }
      this.timeout = setTimeout(() => {
        axios.post("typing");
      }, 500);
    }
  }
};
</script>
